/**
 * Copyright © 2016-2020 The Thingsboard Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.thingsboard.server.dao;

import org.junit.ClassRule;
import org.junit.extensions.cpsuite.ClasspathSuite;
import org.junit.extensions.cpsuite.ClasspathSuite.ClassnameFilters;
import org.junit.runner.RunWith;

import java.util.Arrays;

@RunWith(ClasspathSuite.class)
@ClassnameFilters({
        "org.thingsboard.server.dao.service.sql.*SqlTest"
})
public class SqlDaoServiceTestSuite {

    @ClassRule
    public static CustomSqlUnit sqlUnit = new CustomSqlUnit(
            Arrays.asList("sql/schema-ts-hsql.sql", "sql/schema-entities-hsql.sql", "sql/schema-entities-idx.sql"
                    , "sql/system-data.sql"
                    , "sql/system-test.sql"
            ),
            "sql/hsql/drop-all-tables.sql",
            "sql-test.properties"
    );

//    @ClassRule
//    public static CustomSqlUnit sqlUnit = new CustomSqlUnit(
//            Arrays.asList("sql/schema-ts-psql.sql"
//                    , "sql/schema-entities.sql", "sql/schema-entities-idx.sql"
//                    , "sql/system-data.sql", "sql/system-test.sql"
//            ),
//            "sql/psql/drop-all-tables.sql",
//            "sql-test.properties"
//    );

//    @ClassRule
//    public static CustomSqlUnit sqlUnit = new CustomSqlUnit(
//            Arrays.asList("sql/schema-timescale.sql", "sql/schema-entities.sql", "sql/schema-entities-idx.sql", "sql/system-data.sql", "sql/system-test.sql"),
//            "sql/timescale/drop-all-tables.sql",
//            "sql-test.properties"
//    );

}
